

	.title  " TITOLO DEL PROGRAMMA TRA DOPPI APICI (E' OPZIONALE)"

	.vers   "ST62E10"       ; INDICA IL TIPO DI DISPOSITIVO DA PROGRAMMARE

a       .def    0ffh    ;ACCUMULATOR (REGISTRO ACCUMULATORE)
x       .def    080h    ;X REGISTER  (REGISTRO X)
y       .def    081h    ;Y REGISTER  (REGISTRO Y)
v       .def    082h    ;V REGISTER  (REGISTRO V)
w       .def    083h    ;W REGISTER  (REGISTRO W)


;              DEFINIZIONE DEI REGISTRI DELLE PORTE
;              ------------------------------------

port_a  .def    0c0h    ;PORT A DATA REGISTER
port_b  .def    0c1h    ;PORT B DATA REGISTER
port_c  .def    0c2h    ;PORT C DATA REGISTER
pdir_a  .def    0c4h    ;PORT A DIRECTION REGISTER  (0=Input   1=Output)
pdir_b  .def    0c5h    ;PORT B DIRECTION REGISTER
pdir_c  .def    0c6h    ;PORT C DIRECTION REGISTER
popt_a  .def    0cch    ;PORT A OPTION REGISTER
popt_b  .def    0cdh    ;PORT B OPTION REGISTER
popt_c  .def    0ceh    ;PORT C OPTION REGISTER


;               DEFINIZIONE DEL REGISTRO DEGLI INTERRUPT
;               ----------------------------------------

ior     .def    0c8h    ;INTERRUPT OPTION REGISTER.

;               DEFINIZIONE DEL REGISTRO PER IL CONVERTITORE A/D
;               ------------------------------------------------

addr    .def    0d0h    ;A/D DATA REGISTER (REGISTRO DATI DEL CONVERTITORE)
adcr    .def    0d1h    ;A/D CONTROL REGISTER (REGISTRO DI CONTROLLO)


;               DEFINIZIONE DEI REGISTRI DEL TIMER
;               ----------------------------------

psc     .def    0d2h    ;TIMER PRESCALER REGISTER (REGISTRO DEL PRESCALER)
tcr     .def    0d3h    ;TIMER DATA REGISTER (REGISTRO DATI)
tscr    .def    0d4h    ;TIMER TSCR REGISTER ( REGISTRO PER IL CONTROLLO
			;DELLO STATO DEL TIMER)

;               DEFINIZIONE DEL REGISTRO PER IL WATCH-DOG
;               -----------------------------------------

wdog    .def    0d8h    ;WATCHDOG REGISTER


;              DEFINIZIONE DEL REGISTRO PER LO SPAZIO DATI ROM
;              -----------------------------------------------

drw     .def    0c9h    ;DATA ROM WINDOW REGISTER

;****************************************************************************
;*                         VARIABILI DEL PROGRAMMA                          *
;****************************************************************************

n1    .def    084h    ;DEFINISCE LA VARIABILE PIPPO
n2    .def    085h    ;DEFINISCE LA VARIABILE PLUTO
n3	.def	086h
resto	.def	087h
risult	.def	088h



;;             INIZIO DEL PROGRAMMA
;             --------------------
	.org    0880h	; PER ST6210/15 
;	.ORG	080h	; PER ST6220/25

inizio                  ;  INIZIALIZZAZIONE DELLE PERIFERICHE

	ldi     wdog,0ffh       ; RICARICA IL WATCH DOG
; Questa operazione va ripetuta circa ogni 30 istruzioni per evitare che
; il microprocessore si resetti da solo.

;      SETTAGGIO DELLA PORTA "A" COME OUTPUT PUSH-PULL (10 mA max)
;      -----------------------------------------------------------
					;|	INGRESSI        |  USCITE
					;PULUP-NOPULUP-INTER-ADC-OPEN-PUSHPUL
	 
	ldi     pdir_a,11111111b 	 ;  0  |   0   |  0  | 0 | 1  |  1
	ldi     popt_a,11111111b  	 ;  0  |   0   |  1  | 1 | 0  |  1
	ldi     port_a,00000000b	 ;  0  |   1   |  0  | 1 |0/1 | 0/1

;      SETTAGGIO DELLA PORTA "B" COME INPUT PULL-UP
;      --------------------------------------------

					;|	INGRESSI        |  USCITE
;***  Setta la porta B 			 PULUP-NOPULUP-INTER-ADC-OPEN-PUSHPUL
	        
	ldi     pdir_b,11111111b        ;  0  |   0   |  0  | 0 | 1  |  1
	ldi     popt_b,11111111b        ;  0  |   0   |  1  | 1 | 0  |  1
	ldi     port_b,00000000b	;  0  |   1   |  0  | 1 |0/1 | 0/1

;      SETTAGGIO DELLA PORTA "C" (solo ST6 a 28 pin) COME OUTPUT OPEN DRAIN
;      --------------------------------------------------------------------
	ldi     port_c,00000000b  ;DR_C  data register  0=0V  1=Vcc out
	ldi     pdir_c,11111111b  ;DDR_C data direction register 0=in 1=out
	ldi     popt_c,00000000b  ;OR_C  option reg. 0 se out=open drain
				  ;      1 se out= push-pull	
				  ;      0 se in = with pull-op 
				  ;      1 se in = no pull-op

	ldi     adcr,0         	;DISABLE A/D INTERRUPT
	ldi     tscr,0         	;DISABLE TIMER INTERRUPT
	ldi     ior,0          	;DISABLE ALL INTERRUPT

	reti    		;RIPRISTINA I FLAG PRINCIPALI
	jp      main		;SALTA AL PROGRAMMA PRINCIPALE


;****************************************************************************
;*                       SUBROUTINE DI INTERRUPT                            *
;****************************************************************************

; In questo punto potremmo scrivere le subroutine di interrupt.
; Queste subroutine devono terminare con l'istruzione   reti.
; La subroutine deve percio' essere scritta tra l'etichetta che la
; identifica e l'istruzione reti.

ad_int      	    	;INTERRUPT DEL CONVERTITORE A/D
	reti
tim_int                 ;INTERRUPT DEL TIMER
	reti
BC_int                  ;INTERRUPT DELLE PORTE A e B
	reti
A_int                   ;INTERRUPT DELLA PORTA A
	reti
nmi_int                 ;INTERRUPT NON MASCHERABILE
	reti

;***************************************************************************
;*                         PROGRAMMA PRINCIPALE                            *
;***************************************************************************



main            		;IDENTIFICA L'INIZIO DEL PROGRAMMA PRINCIPALE

	ldi     wdog,254	;carico wdog
	clr	risult		;azzeramento risultato
	ld	a,n1		;carico nel reg a il byte + significativo
	jrnz	div		;se non e` zero salto
	ld	a,n2		;altrimenti prendo byte - significativo
	jp	ancora		;e vado a dividere 
div	ld	a,n2		;prendo il byte - signif.
suba	ldi 	wdog,254
	inc	risult		;suppongo gia` che n3 ci stia una volta in n2
	sub	a,n3		;sottraggo una volta n2-n3 
	jrnc	suba		;se a>= n2 continuo a sottrarre e inc risultato
	dec	n1		;chiedo riporto al byte + significativo
	jrnz	suba		;e se n1 non e` zero continuo a sottrarre
ancora	ldi	wdog,254
	inc	risult		;incremento ancora il risultato
	sub	a,n3		;sottraggo acora
	jrnc	ancora		;e continuo fino a che n2>n3
	dec	risult		;ho finito ma devo sottrarre 1 al risultato
	add	a,n3		;rimetto a come prima dell'ultima sub non valida
	ld	resto,a		;cosi da avere in a il resto 
	jp	main
;****************************************************************************
;*                     VETTORI DI INTERRUPTS                                *
;****************************************************************************

; Questa parte deve essere riportata alla fine del MAIN e prima della
; istruzione finale .END .
; Queste istruzioni non dovranno essere modificate.

	.org    0ff0h
	jp      ad_int  ;INTERRUPT DEL CONV. A/D     vector #4
	jp      tim_int ;INTERRUPT DEL TIMER         vector #3
	jp      BC_int  ;INTERRUPT PORTE A e B       vector #2
	jp      A_int   ;INTERRUPT PORTA A           vector #1
	.org    0ffch
	jp      nmi_int ;INTERRUPT NON MASCHERABILE  vector #0
	jp      inizio  ;INTERRUZIONE PER IL SETTAGGIO INIZIALE
;*****************************************************************************
	.end                    ; Termine del programma





